/*
 * adxl345.c
 *
 *  Created on: 2014/11/14
 *      Author: Tetsuya Suzuki
 */

#include "chip.h"
#include "i2cm.h"
#include "adxl345.h"

void aclWrite(uint8_t reg, uint8_t data){
	uint8_t buf[3];

	buf[0] = ACL_ADRS;
	buf[1] = reg;
	buf[2] = data;
	i2cmTx(buf, 3);
}

uint8_t aclRead(uint8_t reg){
	uint8_t buf[3];

	buf[0] = ACL_ADRS;
	buf[1] = reg;
	i2cmTx(buf, 2);
	i2cmRx(buf, 1);
	return buf[1];
}

void aclSetup(){
	aclWrite(0x31, 0x0b);//Full resolution, 13bit
	aclWrite(0x2d, 0x08);//Measure mode
}

void aclReadAxis(int16_t *x, int16_t *y, int16_t *z){
	uint8_t buf[7];

	buf[0] = ACL_ADRS;
	buf[1] = 0x32;
	i2cmTx(buf, 2);
	i2cmRx(buf, 7);
	*x = buf[1] | ((uint16_t)buf[2] << 8);
	*y = buf[3] | ((uint16_t)buf[4] << 8);
	*z = buf[5] | ((uint16_t)buf[6] << 8);
}
