/*
===============================================================================
 Name        : main.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
#include "uart.h"
#include "form.h"
#include "mrt.h"
#include "i2cm.h"
#include "adxl345.h"

// TODO: insert other definitions and declarations here
int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
    // Read clock settings and update SystemCoreClock variable
    SystemCoreClockUpdate();
    // Set up and initialize all required blocks and
    // functions related to the board hardware
    Board_Init();
    // Set the LED to the state of "On"
    Board_LED_Set(0, true);
#endif
#endif

    // TODO: insert code here
    SystemCoreClockUpdate();

    Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);//Disable SWCLK
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);//Disable SWDIO
 	Chip_SWM_MovablePinAssign(SWM_I2C_SDA_IO, 2);//I2C_SDA
	Chip_SWM_MovablePinAssign(SWM_I2C_SCL_IO, 3);//I2C_SCL
	Chip_SWM_MovablePinAssign(SWM_U0_TXD_O, 4);
	Chip_SWM_MovablePinAssign(SWM_U0_RXD_I, 0);
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	i2cmSetup();
	aclSetup();
	uartSetup();
	mrtSetup();

	uartPuts("ADXL345 ID:");
	uartPuts(formHex(aclRead(0), 2));
	uartPuts("\r\n");

	while(1){
		int16_t x, y, z;

		aclReadAxis(&x, &y, &z);
		uartPuts("X:");
		uartPuts(formDec(x, 4, 0));
		uartPuts(", Y:");
		uartPuts(formDec(y, 4, 0));
		uartPuts(", Z:");
		uartPuts(formDec(z, 4, 0));
		uartPuts("\r\n");
		mrtWait(MRT_MS(1000));
	}
    return 0 ;
}
