/*
 * remocon.h
 *
 *  Created on: 2014/10/31
 *      Author: Tetsuya Suzuki
 */

#ifndef REMOCON_H_
#define REMOCON_H_
#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	uint32_t lon, loff; //leader on / off
	uint32_t t; // mark
	uint32_t h; // space high
	uint32_t l; // space low
	bool multi; // multi shot flag
	uint32_t gap; // from tail of 1st to top of 2nd time
	uint8_t count1, count2; // signal count in bytes
	uint8_t *code1, *code2; // array byte code
} irform_t;

enum {
	RC_ERR_TIMEOUT = -4,
	RC_ERR_ILLEGAL,
	RC_ERR_TOOLONG,
	RC_ERR_NOTFIT,
	RC_ERR_NORMAL
};

void rc_setup(uint8_t irport);
int rc_receive(irform_t *ir);
void rc_transmit(irform_t *ir);
int rc_ircmp(irform_t *ir1, irform_t *ir2);

#define RC_SIGLEN 32 // maximum signal length in bytes
#define RC_CLKS_S 24000000
#define RC_CLKS_MS(ms) (RC_CLKS_S / 1000 * ms)
#define RC_CLKS_US(us) (RC_CLKS_MS(us) / 1000)
#define RC_DTCT RC_CLKS_US(2000)// minimum time in micro second regarded as leader
#define RC_TERM RC_CLKS_MS(10)// timeout in miri second
#define RC_CONT RC_CLKS_MS(50)// the time of wait for next signal in miri second
#define RC_FORM RC_CLKS_US(6500)// leader on time in micro second regarded as AEHA

#ifdef __cplusplus
}
#endif
#endif /* REMOCON_H_ */
