// @brief PWM handler

#include "chip.h"

inline void pwmIntEnable(void){
    Chip_SCT_EnableEventInt(LPC_SCT, SCT_EVT_0);
    NVIC_EnableIRQ(SCT_IRQn);
}
inline void pwmIntDisable(void){
    NVIC_DisableIRQ(SCT_IRQn);
    Chip_SCT_DisableEventInt(LPC_SCT, SCT_EVT_0);
}

inline void pwmStart(void){
	Chip_SCTPWM_Start(LPC_SCT);
}

inline void pwmStop(void){
	Chip_SCTPWM_Stop(LPC_SCT);
	LPC_SCT->OUTPUT = 0;
}

inline void pwmDutySetup(uint8_t ch, uint8_t percent){
	Chip_SCTPWM_SetDutyCycle(LPC_SCT, ch + 1, Chip_SCTPWM_PercentageToTicks(LPC_SCT, percent));
}

void pwmCounterSetup(uint32_t hz){
	Chip_SCTPWM_Init(LPC_SCT);
	Chip_SCTPWM_SetRate(LPC_SCT, hz);
}

void pwmChannelSetup(uint8_t ch, uint8_t percent){
	Chip_SCTPWM_SetDutyCycle(LPC_SCT, ch + 1, Chip_SCTPWM_PercentageToTicks(LPC_SCT, percent));
	Chip_SCTPWM_SetOutPin(LPC_SCT, ch + 1, ch);
}

void oscSetup(uint32_t hz){
	pwmCounterSetup(hz);
	pwmChannelSetup(0, 50);
}
