/*
===============================================================================
 Name        : main.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
#include "aqm0802a.h"
#include "i2cm.h"
#include "mrt.h"

// TODO: insert other definitions and declarations here
int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
    // Read clock settings and update SystemCoreClock variable
    SystemCoreClockUpdate();
    // Set up and initialize all required blocks and
    // functions related to the board hardware
    Board_Init();
    // Set the LED to the state of "On"
    Board_LED_Set(0, true);
#endif
#endif

    // TODO: insert code here
	SystemCoreClockUpdate();

	//Pin assign
	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);
 	Chip_SWM_MovablePinAssign(SWM_I2C_SDA_IO, 2);
	Chip_SWM_MovablePinAssign(SWM_I2C_SCL_IO, 3);
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	const uint8_t squar[] = {
		0x04, 0x0a, 0x02, 0x04,
		0x0e, 0x00, 0x00, 0x00
	};
	const uint8_t heart[] = {
		0x00, 0x0a, 0x1f, 0x1f,
		0x1f, 0x0e, 0x04, 0x00
	};

	mrtSetup();
	i2cmSetup();

	lcdSetup();
	lcdDefChar(0, squar);
	lcdDefChar(1, heart);
	lcdLocate(0, 0);
	lcdDat('I');
	lcdDat(0);
	lcdPuts("C LCD");
	lcdDat(1);
	lcdLocate(0, 1);
	lcdPuts("AQM0802A");

	while(1) __WFI();
    return 0 ;
}
