/*
 ===============================================================================
 Name        : rgb810.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
 ===============================================================================
 */

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
#include "mrt.h"
#include "ws2811.h"

// TODO: insert other definitions and declarations here
static const uint8_t colors[] = {
		0x0f, 0x08, 0x08,
		0x08, 0x0f, 0x08,
		0x0f, 0x0f, 0x00,
		0x08, 0x08, 0x0f,
		0x0f, 0x08, 0x08,
		0x08, 0x0f, 0x08,
		0x0f, 0x0f, 0x00,
};

static const uint8_t colors_dark[] = {
		0x1f, 0x0f, 0x0f,
		0x0f, 0x1f, 0x0f,
		0x1f, 0x1f, 0x00,
		0x0f, 0x0f, 0x1f,
		0x1f, 0x0f, 0x0f,
		0x0f, 0x1f, 0x0f,
		0x1f, 0x1f, 0x00,
};

static const uint8_t colors_half[] = {
		0x7f, 0x3f, 0x3f,
		0x3f, 0x7f, 0x3f,
		0x7f, 0x7f, 0x00,
		0x3f, 0x3f, 0x7f,
		0x7f, 0x1f, 0x1f,
		0x1f, 0x7f, 0x1f,
		0x3f, 0x3f, 0x00
};

static const uint8_t colors_blight[] = {
		0xff, 0x3f, 0x3f,
		0x3f, 0xff, 0x3f,
		0xff, 0xff, 0x00,
		0x3f, 0x3f, 0xff,
		0xff, 0x3f, 0x3f,
		0x3f, 0xff, 0x3f,
		0xff, 0xff, 0x00
};

int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
	// Read clock settings and update SystemCoreClock variable
	SystemCoreClockUpdate();
	// Set up and initialize all required blocks and
	// functions related to the board hardware
	Board_Init();
	// Set the LED to the state of "On"
	Board_RGB_Set(0, true);
#endif
#endif

	// TODO: insert code here
	SystemCoreClockUpdate();

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);	//Disable SWDIO
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_IOCON);
	Chip_IOCON_PinSetMode(LPC_IOCON, IOCON_PIO2, PIN_MODE_INACTIVE);
	Chip_IOCON_PinEnableOpenDrainMode(LPC_IOCON, IOCON_PIO2);
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_IOCON);

	Chip_GPIO_SetPinDIROutput(LPC_GPIO_PORT, 0, 2);
	Chip_GPIO_SetPinOutLow(LPC_GPIO_PORT, 0, 2);

	mrtSetup();

	int count = 0;
	while (1) {
		int top = (count++ & 0x03) * 3;
		rgbWrite(&colors[top], 12);
		//mrtWait(MRT_MS(500));
		mrtWait(MRT_MS(3000));
	}
	return 0;
}
